const Mensagens = require("../infra/repository/mensagens.repository");
const mensagens = new Mensagens();

const jwt = require("jsonwebtoken");

class mensagensController {


  /**
   * Registra um vendedor
   * @returns mensagem referente ao resultado obtido
   */
  register() {
    return function (req, res) {
      const data = req.body;
      const file = req.file;

      console.log('data', data)
      console.log('file', file)

      mensagens
        .register(data, file)
        .then((response) => {
          if (response.error)
            return res.status(response.code).send({ error: response.error });
          else return res.status(200).json(response);
        })
        .catch((error) => {
          console.log(error);
          
          return res
            .status(400)
            .send({ error: `Não foi possível realizar o cadastro!` });
        });
    };
  }

  /**
   * Lista todos os mensagens
   * @returns mensagem referente ao resultado obtido
   */
  listMensagensVinculadas() {
    return function (req, res) {
      const { id } = req.params;
      const id_mensagem = req.query.id_mensagem

      mensagens
        .listMensagensVinculadas(id_mensagem)
        .then((response) => {
          if (response.error)
            res.status(response.code).send({ error: response.error });
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }

  /**
   * Lista todos os mensagens
   * @returns mensagem referente ao resultado obtido
   */
    listMensagens() {
      return function (req, res) {
        const { id } = req.params;
  
        mensagens
          .listMensagens(id)
          .then((response) => {
            if (response.error)
              res.status(response.code).send({ error: response.error });
            else return res.status(200).send(response);
          })
          .catch((error) => {
            throw new Error(error);
          });
      };
    }

      /**
   * Lista todos os mensagens
   * @returns mensagem referente ao resultado obtido
   */
      listAssuntoMensagens() {
        return function (req, res) {
          const { id } = req.params;
    
          mensagens
            .listAssuntoMensagens(id)
            .then((response) => {
              if (response.error)
                res.status(response.code).send({ error: response.error });
              else return res.status(200).send(response);
            })
            .catch((error) => {
              throw new Error(error);
            });
        };
      }

  /**
   * Delete um vendedor
   * @returns mensagem referente ao resultado obtido
   */
  delete() {
    return function (req, res) {
      const { id } = req.params;

      mensagens
        .delete(id)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }

  desvincularMensagem() {
    return function (req, res) {
      const  data  = req.body;

      mensagens
        .desvincularMensagem(data)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }
  /**
   * Atualiza os dados de um vendedor
   * @returns mensagem referente ao resultado obtido
   */
  update() {
    return function (req, res) {
      const data = req.body;
      const file = req.file;

      mensagens
        .update(data, file)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }

  vincularUsuarioMensangem() {
    return function (req, res) {
      const data = req.body;

      mensagens
        .vincularUsuarioMensangem(data)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }

  enviarLembreteParaUsuario() {
    return function (req, res) {
      const data = req.body;

      mensagens
        .enviarLembreteParaUsuario(data)
        .then((response) => {
          if (response.error) res.status(response.code).send(response);
          else return res.status(200).send(response);
        })
        .catch((error) => {
          throw new Error(error);
        });
    };
  }


}

module.exports = mensagensController;

