const {
    decrypt,
    encrypt,
    generateHash,
    checkHash,
  } = require("../../config/auth/cryptography");
  const { genereteToken } = require("../../config/auth/jwt");
  const { encryptDonor, decryptDonor } = require("../../util/cryptDonor");
  const db = require("../database/db");
  const nodemailer = require("nodemailer");
  const crypto = require("crypto");
  const { response } = require("express");
  const { getMaxListeners } = require("../database/db");
  const path = require("path");
  
  require("dotenv").config({ path: __dirname + "/./../../../.env" });
  
  class logsRepository {
  
    constructor() {
      this.db = db;
    }
  
    /**
     * Lista os dados de um log
     * @returns lista com todos os dados de um log
     */
    list(id) {
      return new Promise(async (resolve, reject) => {
        var query = id
          ? `WHERE id = ?`
          :``
  
        try {
          this.db.query(`SELECT * FROM logs ${query}`, [id ? id : ""], 
          async (error, produtos) => {
            
            if (error) { 
              
              console.log(error);
              return reject(new Error(error));
            }
  
            return resolve(produtos);
          });
        } catch (error) {
          return reject(new Error(error));
        }
      });
    }

  /**
   * Lista todos os logs 
   * @returns lista com todos os logs 
   */
      listlogsByUser(id_user) {
        return new Promise(async (resolve, reject) => {
        
          try {
            this.db.query(`SELECT
                        logs.acao,
                        DATE_FORMAT(logs.data, "%d/%m/%Y") AS data,
                        COUNT(CASE WHEN logs.id_user IS NOT NULL THEN 1 END) AS quantidade_logado,
                          COUNT(CASE WHEN logs.id_user IS NULL THEN 1 END) AS quantidade_deslogado
                      FROM logs
                      left JOIN 
                        user ON user.id = logs.id_user
                      WHERE
                      logs.acao NOT LIKE "%Login%"
                      GROUP BY 
                      DATE_FORMAT(logs.data, "%d/%m/%Y"), logs.acao
                      ORDER BY
                      logs.data DESC`
            ,[id_user ? id_user : ``], 
            async (error, logs) => {
              if (error) { 
                console.error(error);
                return reject(new Error(error));
              }
              const filteredLogs = logs.map(log => {
                if (log.quantidade_deslogado === 0) delete log.quantidade_deslogado;
                // if(process.env.NODE_ENV != "production") { 
                //   log.acao === "Entrou na pagina de produtos" ? log.quantidade_logado = log.quantidade_logado / 2 : ``
                // }
                             
                return log;
            });

            return resolve(filteredLogs);
            });
          } catch (error) {
            return reject(new Error(error));
          }
        });
      }


    /**
     * Deleta uma unidade cadastrada
     * @param {*} id Id da unidade a ser excluída
     * @returns mensagem referente ao resultado obtido
     */
    delete(id) {
      return new Promise((resolve, reject) => {
  
        this.db.query('DELETE FROM logs WHERE id = ?', [id],
        (error, response) => {
            if (error) {
                return resolve({ error: "Esta logs possui vinculos!", code: 203 });
            }
            else {
                return resolve(true);
            }
        });
      });
    }

       /**
     * Deleta uma unidade cadastrada
     * @param {*} id Id da unidade a ser excluída
     * @returns mensagem referente ao resultado obtido
     */
       deletePedidoByUserId(id_user) {
        return new Promise((resolve, reject) => {
    
          this.db.query('DELETE FROM pedidos WHERE id_user = ?', [id_user],
          (error, response) => {
              if (error) {
                  return resolve({ error: "Este pedidos possui vinculos!", code: 203 });
              }
              else {
                  return resolve(true);
              }
          });
        });
      }
    
  
}
  
  module.exports = logsRepository;
  