const express = require("express");
const routes = express.Router();
const auth = require("../config/auth/auth");

const FuncionarioController = require("../controller/funcionario.controller");
const funcionarioController = new FuncionarioController();

const ProdutosController = require("../controller/produtos.controller");
const produtosController = new ProdutosController();



routes.post("/register", funcionarioController.register());
routes.post("/login", funcionarioController.login());
routes.get("/perfil", funcionarioController.listFuncionarioById());
routes.get("/pedidoPendentes", funcionarioController.listPedidosPendentes());
routes.get("/produto", funcionarioController.listProdutoFunc());
routes.patch("/adicionarProduto", funcionarioController.registerPedido());
routes.patch("/quantidadeProduto", funcionarioController.updateQuantidade());
routes.delete("/deletarItem", funcionarioController.deleteProdutoDoPedido());
routes.get("/tabelaPreco", funcionarioController.listTabelaDePrecoFunc());
routes.patch("/concluirPedido", funcionarioController.concluirPedido());







module.exports = routes;